%% Main
%clear all; close all; clc;
tic;
%% Initializing parameters
%parameters;
%parameters_v2;
parameters_v3;

%% Generating random population R_0
% R_0: size 2*N
% Evaluating objective functions for initial population, i.e. calls OFE()
R_0 = initialize_population(N, V, K, M, start_pos, final_pos,...
                                    min_range, max_range,...
                                    min_dist, obs_vec, z_terrain, pen_pos);
                                
%% Non-dominated sorting and crowding distance assignment of R_0
% tic;
R_0 = NDS_CDA_rev2(R_0, V, K, M);
% toc; 
%% Binary Tournament Selection - generating initial parent population P_0
% P_0: size N
P = BTS(R_0, N, V, K, M);

%% Generating initial offspring population Q_0
% Q_0: size N
% Objective function evaluation is carried out for offspring population,
% i.e. calls OFE()
% Q = make_new_pop(P, V, K, M,... 
%                      p_c, eta_c, p_m, eta_m,...
%                      min_range, max_range,...
%                      min_dist, obs_vec, z_terrain);

Q = make_new_pop_rev3(P, V, K, M,... 
                     p_c, eta_c, p_m, eta_m,...
                     min_range, max_range,...
                     min_dist, obs_vec, start_pos, final_pos,...
                     z_terrain, pen_pos);

%% Main loop
for i = 1:G
    %% Intermediate Solution R
    % R_1: size 2*N
    % R_1 is obtained by concatenation of P_0 and Q_0
    R(1:N,:) = P;
    R(N+1:2*N,:) = Q;
    
    %% Non-dominated sorting and crowding distance assignment of R
%     tic;
    R = NDS_CDA_rev2(R, V, K, M);
%     toc;
    
    %% Selecting next parent generation, P
    P = selection(R, N, V, K, M);
    
    %% Generating next offspring population Q
%     Q = make_new_pop(P, V, K, M,... 
%                      p_c, eta_c, p_m, eta_m,...
%                      min_range, max_range,...
%                      min_dist, obs_vec, z_terrain);
                 
%     Q = make_new_pop_rev2(P, V, K, M,... 
%                         p_c, eta_c, p_m, eta_m,...
%                         min_range, max_range,...
%                         min_dist, obs_vec, start_pos, final_pos, z_terrain);
        Q = make_new_pop_rev3(P, V, K, M,... 
                     p_c, eta_c, p_m, eta_m,...
                     min_range, max_range,...
                     min_dist, obs_vec, start_pos, final_pos,...
                     z_terrain, pen_pos);
                 
     %% Print
%      if ~mod(i,100)
%         fprintf('%i generation \n', i);
%         disp(P);
%      end
end
toc;
%% Plotting results
%utilities;
% path_selector;
path_selector_v2;
nbPath = a_index;
%plot_tool_v2;
plot_tool_v3;
toc;



