%% Parameters

deg2rad = pi/180;
%% NSGA-II parameters:
N = 100; % Population size
G = 500;

V = 3; % Number of design variables are x,y and z. NOTE: ACTUALLY  V = 3*Number of waypoints??
M = 4; % Number of objective functions, f(1), f(2) and f(3)

%% Environment parameters
length_last_segment = 20;

% Penultimate position
x_pen = final_pos(1) + cos(heading_final)*(-length_last_segment);
y_pen = final_pos(2) - sin(heading_final)*(-length_last_segment);
z_pen = final_pos(3);
pen_pos = [x_pen, y_pen, z_pen];

% Asuming input
x0 = start_pos(1);
y0 = start_pos(2);
z0 = start_pos(3);

x_final = final_pos(1);
y_final = final_pos(2);
z_final = final_pos(3);

% Variable bounds
xxmin = [x0, x_final, x_pen];
xxmax = [x0, x_final, x_pen];
yymin = [y0, y_final, y_pen];
yymax = [y0, y_final, y_pen];

x_min = min(xxmin) - 1;
x_max = max(xxmax) + 1;
y_min = min(yymin) - 1;
y_max = max(yymax) + 1;

z_min = 0;
%z_max = 101;
z_terrain = z_max - 31; 

% Range vectors
max_range = [x_max, y_max, z_max];
min_range = [x_min, y_min, z_min];

% Assuming spherical obstacle, with the following radius
radius_obs = 10;

% Minimum accepted distance from obstacle in meters
min_dist = radius_obs + 5; 

%% Parameters for Genetic Operations

% Simulated Binary Crossover (SBX) parameters
p_c = 0.9; % Crossover probability
eta_c = 5; % Distribution index, 20 suggested by literature

% Polynomial Mutation
p_m = 0.1; % Mutation problability
eta_m = 20; % Distribution index




